<template>
  <q-page class="bg-grey-2 q-pa-sm">
    <div class="col-xs-6 col-sm-6 col-md-4 col-lg-3 col-xl-2">
      <q-card class="shadow-up-24 q-pb-xs">
        <q-card-section class="text-white bg-primary">
          <div
            class="text-h6"
            style="text-align: center"
          >
          Crear deuda Estudiantil
          </div>
        </q-card-section>
        <q-card-section>
          <div class="col-xs-12 col-sm-10 col-md-6 col-xl-6" style="margin-left: 1%; margin-top: 1%;">
            <q-select clearable filled behavior="menu" color="primary-12" v-model="student" :options="options" label="Estudiantes" />
          </div>
          <div class="col-xs-12 col-sm-8 col-md-4 col-xl-4 row items-center justify-center" style="margin-left: 1%; margin-top: 1%;">
            <q-btn label="Agregar" class="bg-primary text-white" icon="add" @click="send(student)">
              <q-tooltip  content-class="bg-white text-black shadow-4" :offset="[10, 10]">
                Agregar Deuda
               </q-tooltip>
            </q-btn>
          </div>
        </q-card-section>
          <q-card-section>
            <q-dialog v-model="band" persistent>
              <q-card>
                <q-card-section class="bg-primary text-white">
                  <div class="text-h6">Datos</div>
                </q-card-section>
                <q-card-section class="q-pt-note">
                  <q-select clearable dense filled behavior="menu" color="primary-12" v-model="count" :options="buys" label="Tipo" style="margin-top: 1em; width: 100%;"/>
                  </q-card-section>
                 <q-card-actions align="right" class="text-primary">
                 <q-btn flat label="Agregar" @click="add(count, student)"/>
                 <q-btn flat label="Cancelar" @click="reset()"/>
               </q-card-actions>
              </q-card>
            </q-dialog>
          </q-card-section>
          <q-card-section>
            <div v-if="everyBuys.length > 0">
            <q-layout view="lHh Lpr lFf" container style="height: 300px" class="shadow-2 rounded-borders">
              <q-header elevated class="bg-negative">
                <q-toolbar>
                  <q-toolbar-title class="text-h6">
                    <strong>Datos</strong>
                  </q-toolbar-title>
                   <q-btn
                    flat
                    class="bg-white text-black"
                    icon="save"
                    label="Deudas"
                    @click="Generat()"
                  >
                  <q-tooltip anchor="top middle" self="bottom middle" content-class="bg-negative text-black shadow-4" :offset="[10, 10]">
                    Generar Deuda
                  </q-tooltip>
              </q-btn>
                </q-toolbar>
              </q-header>

              <q-page-container>
                <q-page style="padding-top: 1%;">
                  <div v-for="(date, index) in everyBuys" :key="index">
                    <q-intersection transition="rotate">
                    <q-list style="margin-bottom: 1px;">
                      <q-expansion-item class="shadow-1 overflow-hidden" style="border-radius: 10px" header-class="bg-accent text-white" group="group2" dense dense-toggle expand-separator :label="date.name" expand-icon-class="text-white">
                        <q-card>
                          <q-card-section>
                            <div class="row">
                              <div class="col">
                                <div>
                                  <strong>Nombre: </strong> {{date.name}} <br>
                                  </div>
                              </div>
                              <div class="col">
                                <strong>Cantidad: </strong> {{date.buy}} <br>
                              </div>
                              <div class="col" style="margin-left: -10%;">
                              <q-btn
                                color="red"
                                flat
                                round
                                icon="delete"
                                @click="deleteItem(index)"
                              >
                              <q-tooltip  content-class="bg-red text-white shadow-4" :offset="[10, 10]">
                              Eliminar entrada
                            </q-tooltip>
                            </q-btn>
                            </div>
                            </div>
                          </q-card-section>
                        </q-card>
                      </q-expansion-item>
                    </q-list>
                    </q-intersection>
                  </div>
                  <q-page-scroller position="bottom-right" :scroll-offset="150" :offset="[18, 18]">
                    <q-btn fab icon="keyboard_arrow_up" color="accent" />
                  </q-page-scroller>
                </q-page>
              </q-page-container>
            </q-layout>
          </div>
          </q-card-section>
      </q-card>
    </div>
  </q-page>
</template>
<script>
export default {
  created () {
    this.infoSolicity()
  },
  data () {
    return {
      select: [],
      student: {},
      options: [],
      band: false,
      count: '',
      buys: [],
      everyBuys: []
    }
  },
  methods: {
    infoSolicity () {
      this.$q.loading.show()
      this.$api.get('StudentAprovated_List').then(res => {
        const dates = res
        for (const i in dates) {
          this.options.push({ label: dates[i].name + ' - ' + dates[i].carrera, value: dates[i].dni, id: dates[i].id })
        }
      })
      this.$api.get('CounterList').then(res => {
        const dates = res
        for (const i in dates) {
          this.buys.push({ label: dates[i].concept, value: dates[i].count, cod: dates[i].cod, id: dates[i].id })
        }
        this.$q.loading.hide()
      })
    },
    send (val) {
      if (val.id === undefined) {
        this.$q.notify({
          position: 'center',
          textColor: 'white',
          icon: 'warning',
          color: 'red',
          message: 'Por favor selecciona un Estudiante'
        })
      } else {
        this.band = true
      }
    },
    add (val, student) {
      this.everyBuys.push({ user_id: student.id, buy_id: val.id, buy: (val.value), name: val.label, aprovated: false })
      console.log(this.everyBuys, 'fkhbdsjb')
      this.count = ''
      this.band = false
    },
    reset () {
      this.band = false
    },
    resetAll () {
      this.everyBuys = []
    },
    deleteItem (val) {
      this.everyBuys.splice(val, 1)
    },
    Generat () {
      for (const i in this.everyBuys) {
        delete this.everyBuys[i].name
        delete this.everyBuys[i].buy
      }
      this.$q.loading.show()
      this.$api.post('AddAttachStudents', this.everyBuys).then(res => {
        this.resetAll()
        this.student = ''
        this.$q.loading.hide()
      })
    }
  }
}
</script>
